# ncurses 5.9 - patch  - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 5.9 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 5.9 are in the subdirectory
# 	ftp://invisible-island.net/ncurses/5.9
#
# ------------------------------------------------------------------------------
# ftp://invisible-island.net/ncurses/5.9/ncurses-5.9-20140712.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sat Jul 12 23:53:41 UTC 2014
# ------------------------------------------------------------------------------
# NEWS                             |    7 ++++++-
# dist.mk                          |    4 ++--
# ncurses/curses.priv.h            |    8 ++++----
# ncurses/tty/tty_update.c         |   26 +++++++++++++++++---------
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# 10 files changed, 39 insertions(+), 26 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.2236 
--- ncurses-5.9-20140705+/NEWS	2014-07-05 20:39:04.000000000 +0000
+++ ncurses-5.9-20140712/NEWS	2014-07-12 20:24:13.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.2236 2014/07/05 20:39:04 tom Exp $
+-- $Id: NEWS,v 1.2239 2014/07/12 20:24:13 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,11 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20140712
+	+ correct Charable() macro check for A_ALTCHARSET in wide-characters.
+	+ build-fix for position-debug code in tty_update.c, to work with or
+	  without sp-funcs.
+
 20140705
 	+ add w/W toggle to ncurses.c 'B' test, to demonstrate permutation of
 	  video-attributes and colors with double-width character strings.
Index: dist.mk
Prereq:  1.995 
--- ncurses-5.9-20140705+/dist.mk	2014-07-05 18:50:25.000000000 +0000
+++ ncurses-5.9-20140712/dist.mk	2014-07-12 14:47:53.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.995 2014/07/05 18:50:25 tom Exp $
+# $Id: dist.mk,v 1.996 2014/07/12 14:47:53 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 5
 NCURSES_MINOR = 9
-NCURSES_PATCH = 20140705
+NCURSES_PATCH = 20140712
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: ncurses/curses.priv.h
Prereq:  1.537 
--- ncurses-5.9-20140705+/ncurses/curses.priv.h	2014-05-03 21:20:12.000000000 +0000
+++ ncurses-5.9-20140712/ncurses/curses.priv.h	2014-07-12 20:06:11.000000000 +0000
@@ -34,7 +34,7 @@
  ****************************************************************************/
 
 /*
- * $Id: curses.priv.h,v 1.537 2014/05/03 21:20:12 tom Exp $
+ * $Id: curses.priv.h,v 1.538 2014/07/12 20:06:11 tom Exp $
  *
  *	curses.priv.h
  *
@@ -1458,11 +1458,11 @@
 				AttrOf(dst) |= (attr_t) (ext + 1)
 
 #define if_WIDEC(code)  code
-#define Charable(ch)	((SP_PARM->_legacy_coding)			\
+#define Charable(ch)	(((SP_PARM->_legacy_coding)			\
 			 || (AttrOf(ch) & A_ALTCHARSET)			\
-			 || (!isWidecExt(ch) &&				\
+			 || (!isWidecExt(ch))) &&			\
 			     (ch).chars[1] == L'\0' &&			\
-			     _nc_is_charable(CharOf(ch))))
+			     _nc_is_charable(CharOf(ch)))
 
 #define L(ch)		L ## ch
 #else /* }{ */
Index: ncurses/tty/tty_update.c
Prereq:  1.277 
--- ncurses-5.9-20140705+/ncurses/tty/tty_update.c	2014-02-01 22:09:27.000000000 +0000
+++ ncurses-5.9-20140712/ncurses/tty/tty_update.c	2014-07-12 23:16:30.000000000 +0000
@@ -82,7 +82,7 @@
 
 #include <ctype.h>
 
-MODULE_ID("$Id: tty_update.c,v 1.277 2014/02/01 22:09:27 tom Exp $")
+MODULE_ID("$Id: tty_update.c,v 1.279 2014/07/12 23:16:30 tom Exp $")
 
 /*
  * This define controls the line-breakout optimization.  Every once in a
@@ -179,7 +179,7 @@
     }
 }
 #else
-#define position_check(sp, expected_y, expected_x, legend)	/* nothing */
+#define position_check(expected_y, expected_x, legend)	/* nothing */
 #endif /* POSITION_DEBUG */
 
 /****************************************************************************
@@ -194,13 +194,17 @@
     TR(TRACE_MOVE, ("GoTo(%p, %d, %d) from (%d, %d)",
 		    (void *) SP_PARM, row, col, SP_PARM->_cursrow, SP_PARM->_curscol));
 
-    position_check(SP_PARM, SP_PARM->_cursrow, SP_PARM->_curscol, "GoTo");
+    position_check(NCURSES_SP_ARGx
+		   SP_PARM->_cursrow,
+		   SP_PARM->_curscol, "GoTo");
 
     TINFO_MVCUR(NCURSES_SP_ARGx
 		SP_PARM->_cursrow,
 		SP_PARM->_curscol,
 		row, col);
-    position_check(SP_PARM, SP_PARM->_cursrow, SP_PARM->_curscol, "GoTo2");
+    position_check(NCURSES_SP_ARGx
+		   SP_PARM->_cursrow,
+		   SP_PARM->_curscol, "GoTo2");
 }
 
 static NCURSES_INLINE void
@@ -390,7 +394,7 @@
 
 	PutAttrChar(NCURSES_SP_ARGx ch);
 	SP_PARM->_curscol--;
-	position_check(SP_PARM,
+	position_check(NCURSES_SP_ARGx
 		       SP_PARM->_cursrow,
 		       SP_PARM->_curscol,
 		       "exit_am_mode");
@@ -449,7 +453,7 @@
     } else {
 	SP_PARM->_curscol--;
     }
-    position_check(SP_PARM,
+    position_check(NCURSES_SP_ARGx
 		   SP_PARM->_cursrow,
 		   SP_PARM->_curscol,
 		   "wrap_cursor");
@@ -469,7 +473,9 @@
     if (SP_PARM->_curscol >= screen_columns(SP_PARM))
 	wrap_cursor(NCURSES_SP_ARG);
 
-    position_check(SP_PARM, SP_PARM->_cursrow, SP_PARM->_curscol, "PutChar");
+    position_check(NCURSES_SP_ARGx
+		   SP_PARM->_cursrow,
+		   SP_PARM->_curscol, "PutChar");
 }
 
 /*
@@ -1570,7 +1576,7 @@
 	    UpdateAttrs(SP_PARM, blank);
 	    NCURSES_PUTP2("clear_screen", clear_screen);
 	    SP_PARM->_cursrow = SP_PARM->_curscol = 0;
-	    position_check(SP_PARM,
+	    position_check(NCURSES_SP_ARGx
 			   SP_PARM->_cursrow,
 			   SP_PARM->_curscol,
 			   "ClearScreen");
@@ -1660,7 +1666,9 @@
 	    count--;
 	}
     }
-    position_check(SP_PARM, SP_PARM->_cursrow, SP_PARM->_curscol, "InsStr");
+    position_check(NCURSES_SP_ARGx
+		   SP_PARM->_cursrow,
+		   SP_PARM->_curscol, "InsStr");
 }
 
 /*
Index: package/debian-mingw/changelog
--- ncurses-5.9-20140705+/package/debian-mingw/changelog	2014-07-05 18:50:25.000000000 +0000
+++ ncurses-5.9-20140712/package/debian-mingw/changelog	2014-07-12 14:47:53.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9-20140705) unstable; urgency=low
+ncurses6 (5.9-20140712) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 05 Jul 2014 14:50:25 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 12 Jul 2014 10:47:53 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-5.9-20140705+/package/debian-mingw64/changelog	2014-07-05 18:50:25.000000000 +0000
+++ ncurses-5.9-20140712/package/debian-mingw64/changelog	2014-07-12 14:47:53.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9-20140705) unstable; urgency=low
+ncurses6 (5.9-20140712) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 05 Jul 2014 14:50:25 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 12 Jul 2014 10:47:53 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-5.9-20140705+/package/debian/changelog	2014-07-05 18:50:25.000000000 +0000
+++ ncurses-5.9-20140712/package/debian/changelog	2014-07-12 14:47:53.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9-20140705) unstable; urgency=low
+ncurses6 (5.9-20140712) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 05 Jul 2014 14:50:25 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 12 Jul 2014 10:47:53 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.50 
--- ncurses-5.9-20140705+/package/mingw-ncurses.nsi	2014-07-05 18:50:25.000000000 +0000
+++ ncurses-5.9-20140712/package/mingw-ncurses.nsi	2014-07-12 14:47:53.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.50 2014/07/05 18:50:25 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.51 2014/07/12 14:47:53 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "5"
 !define VERSION_MINOR "9"
 !define VERSION_YYYY  "2014"
-!define VERSION_MMDD  "0705"
+!define VERSION_MMDD  "0712"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-5.9-20140705+/package/mingw-ncurses.spec	2014-07-05 18:50:25.000000000 +0000
+++ ncurses-5.9-20140712/package/mingw-ncurses.spec	2014-07-12 14:47:53.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 5.9
-Release: 20140705
+Release: 20140712
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-5.9-20140705+/package/ncurses.spec	2014-07-05 18:50:25.000000000 +0000
+++ ncurses-5.9-20140712/package/ncurses.spec	2014-07-12 14:47:53.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 5.9
-Release: 20140705
+Release: 20140712
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
